/*

Copyright (c) 1992 Novell, Inc.  All Rights Reserved.

THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
THAT CONTAINS THIS WORK.

Pursuant to the SDK License Agreement, Novell hereby grants to
Developer a royalty-free, non-exclusive license to include the
sample code SIPXCHTC.C and derivative binaries in its product.
Novell grants to Developer worldwide distribution rights to market,
distribute or sell the sample code SIPXCHTC.C and derivative
binaries as a component of Developer's product(s).  Novell shall
have no obligations to Developer or Developer's customers with
respect to this code.

DISCLAIMER:

	Novell, Inc. makes no representations or warranties with respect
to the contents or use of this code, and specifically disclaims any
express or implied warranties of merchantability or fitness for any
particular purpose.  Further, Novell, Inc. reserves the right to revise
this publication and to make changes to its content, at any time,
without obligation to notify any person or entity of such revisions or
changes.

	Further, Novell, Inc. makes no representations or warranties with
respect to any software, and specifically disclaims any express or
implied warranties of merchantability or fitness for any particular
purpose.  Further, Novell, Inc. reserves the right to make changes to
any and all parts of the software, at any time, without obligation to
notify any person or entity of such changes.

***************************************************************************
	SIPXCHTC.C
**************************************************************************/

/**************************************************************************
** Description: This sample code demonstrates how to use the new NWSIPX 
** 				 32-bit libraries for WIN95 or NT. This is the client side
**              of this Group Chat application. Ensure that you also 
**              look at SIPXCHTS.C in order to see the Server sample code.
**	             
**               
** Compiler:     Borland C++ v4.5
**
** Programmer :  Karl Bunnell
** Date:         09/29/1995
**
*/
#include <windows.h> 
#include <stdlib.h>
#include <stdio.h>
#include <mem.h>
#include <string.h>

#define N_PLAT_MSW4
#include <ntypes.h>     
#include <nwsipx32.h>
#include "sipxchtc.h"

#define MAX_MESSAGE_SIZE	1024

long FAR PASCAL _export WndProc(HWND, UINT, UINT, LONG);
DWORD ReceiveThread(PRCV_THREADINFO );
DWORD SendThread( PSND_THREADINFO );
BOOL strToHex(char *ascii, unsigned char *hex, int length);

BOOL InitConnection(NETADDR *pNetAddress, 
						  HWND hwnd, 
						  PSIPXCONN_HANDLE sipxHandle,
						  pnuint8   initCompleteFlag);

BOOL FAR PASCAL GetNetAddressDlgProc(HWND hDlg, WORD msg, WORD wParam, DWORD lParam);
char  globalMessage[1024];
char  tempMessage[1024];
nuint32	tsduSize;

static char inetString[29];
static HANDLE globalhInstance;
static char myName[16];


/*-----------------------------------------------------------------------------
**
*/
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance,
										LPSTR lpszCmdLine, int nCmdShow)
{
	static char	szSIPXCHTC[] = "SIPXCHTC";
	HWND				hwnd;
	MSG					msg;
	WNDCLASS		wndclass;

	if(!hPrevInstance)
	{
		wndclass.style					= CS_HREDRAW | CS_VREDRAW;

		wndclass.lpfnWndProc		=	WndProc;
		wndclass.cbClsExtra			=	0;
		wndclass.cbWndExtra			=	DLGWINDOWEXTRA;
		wndclass.hInstance			=	hInstance;
		wndclass.hIcon					=	LoadIcon(NULL, IDI_APPLICATION);
		wndclass.hCursor				= LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground	= GetStockObject(WHITE_BRUSH);
		wndclass.lpszMenuName		=	NULL;
		wndclass.lpszClassName	= szSIPXCHTC;

		RegisterClass(&wndclass);
	}

	hwnd = CreateDialog(hInstance, "MainDialog", 0, NULL);

	globalhInstance = hInstance;

	SendMessage(hwnd, WM_INITWINDOW, NULL, NULL);

	ShowWindow(hwnd, nCmdShow);
	while(GetMessage(&msg, NULL, 0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;

}
//-----------------------------------------------------------------------------
long far PASCAL _export WndProc ( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam )
{
	static 	char fromName[25];
	PNWTCB	pTermNWTCB = 0;
	FRAGMENT termFrag;
	NETADDR	netAddress;
	static SIPXCONN_HANDLE sipxHandle;
	static RCV_THREADINFO	rcvThreadInfo;
	static SND_THREADINFO	sndThreadInfo;
	nuint32 sipxStatus;
	nuint32 tsduSize;
	nuint32 textLength;
	static nuint8	initCompleteFlag = 0;
	char  displayMessage[1024];
		 
	 switch (message)
	 {

		  case WM_INITWINDOW:

			if(!InitConnection(&netAddress, hwnd, &sipxHandle, &initCompleteFlag ))
				{
				PostMessage(hwnd, WM_DESTROY, 0, 0);
				return FALSE;
				}

			/*--------------------------------------------------------------------
			** The rcvThreadInfo.terminateFlag is used to signal the thread that 
			** the application is terminating. This will allow the thread to 
			** drop out of the receive loop, clean-up, then return.
			*/
			rcvThreadInfo.terminateFlag = 1;
			rcvThreadInfo.connHandle = sipxHandle;
			rcvThreadInfo.hwnd = hwnd;
			rcvThreadInfo.threadHandle = CreateThread(
								/* Security attributes */ NULL,
								/* Stack size (default)*/ 0,
								/* thread function     */ (LPTHREAD_START_ROUTINE) ReceiveThread,
								/* user def. parameter */ &rcvThreadInfo,
								/* Flags               */ 0,
								/* thread ID			  */ &rcvThreadInfo.threadID
								);

			wsprintf(fromName, "\r\n--From: %s\r\n", myName);

			sndThreadInfo.connHandle = sipxHandle;
			sndThreadInfo.hwnd = hwnd;
			memcpy(&sndThreadInfo.netAddress, &netAddress, sizeof(NETADDR));
			strcpy(sndThreadInfo.myName, fromName);


			break;




		  case WM_DESTROY :
				if(initCompleteFlag)
					{
					 rcvThreadInfo.terminateFlag = 0;
					 sipxStatus = NWSipxPoll(
										/* ptr NWTCB          */ rcvThreadInfo.rcvNWTCB
										);
					 if (sipxStatus == SIPX_PENDING)
						{
						sipxStatus = NWSipxCancelPendingRequest(
											/* ptr NWTCB           */ rcvThreadInfo.rcvNWTCB
											);
						if (SIPX_ERROR(sipxStatus))
							{
							wsprintf(displayMessage, "NWSipxCancelPendingRequest() returned %08X", sipxStatus);
							MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
							}
					 
						}

                  	sipxStatus = NWSipxAllocControlBlock(
												/* Sync Type        */ SIPX_API_EVENT,
												/* pEventInfo		  */ NULL,
												/* Pnt NWTCB   	  */ &pTermNWTCB
												);

						if (SIPX_ERROR(sipxStatus))
							{
							wsprintf(displayMessage, "NWSipxAllocControlBlock() returned %08X", sipxStatus);
							MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
							return FALSE;
							}
	
						/*--------------------------------------------------------------------
						** Set up NWTCB fields for send.
						*/

						memcpy(&pTermNWTCB->TCBRemoteAddress, &netAddress, sizeof(NETADDR));
						tsduSize =  NWSipxGetMaxTsduSize(sipxHandle);
						termFrag.FLength = tsduSize;
						termFrag.FAddress = GlobalAlloc(GPTR, termFrag.FLength);
						pTermNWTCB->TCBConnHandle = sipxHandle;
						pTermNWTCB->TCBFragmentList = &termFrag;
						pTermNWTCB->TCBFragmentCount = 1;

					 pTermNWTCB->TCBFlags = SIPX_TERM_ACKED;

					 sipxStatus = NWSipxTerminateConnection(
										/* ptr NWTCB           */ pTermNWTCB
										);
					 if (SIPX_ERROR(sipxStatus))
						{
						wsprintf(displayMessage, "NWSipxTerminateConnection() returned %08X", sipxStatus);
						MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
						NWSipxFreeControlBlock(pTermNWTCB);
						GlobalFree(termFrag.FAddress);
						PostQuitMessage(0);
						return FALSE;
						}            
					 
					 sipxStatus = NWSipxWaitForSingleEvent(
										/* ptr NWTCB          */ pTermNWTCB,
										/* time out interval  */ 3000
										);

					 if (SIPX_ERROR(sipxStatus))
						{
						wsprintf(displayMessage, "NWSipxWaitForSingleEvent() returned %08X", sipxStatus);
						MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
						NWSipxFreeControlBlock(pTermNWTCB);
						GlobalFree(termFrag.FAddress);
						PostQuitMessage(0);
						return FALSE;
						}            

					}
				 PostQuitMessage(0);

				return FALSE;

		  case WM_COMMAND:
				switch(LOWORD(wparam))
				{
					 case IDC_EXIT:
							PostMessage(hwnd, WM_DESTROY, 0, 0);
							break;

					 case IDC_SEND:

					textLength = SendDlgItemMessage(hwnd, IDC_SEND_DATA, WM_GETTEXTLENGTH, 0, 0);

					if(textLength == 0)
						{
						wsprintf(displayMessage, "No data to send! Type message in Data Window then click on 'Send' button.", sipxStatus);
						MessageBox(NULL, displayMessage,"No Data to Send", MB_OK);
						break; 
						}
						 
					sndThreadInfo.threadHandle = CreateThread(
												/* Security attributes */ NULL,
												/* Stack size (default)*/ 0,
												/* thread function     */ (LPTHREAD_START_ROUTINE) SendThread,
												/* user def. parameter */ &sndThreadInfo,
												/* Flags               */ 0,
												/* thread ID			  */ &sndThreadInfo.threadID
												);

					break;

				}                                 	

	 }
	return DefWindowProc(hwnd, message, wparam, lparam);
}

DWORD SendThread( PSND_THREADINFO pSndThreadInfo)
{

	PNWTCB	pSndNWTCB = 0;
	FRAGMENT sndFrag;
	nuint32	tsduSize;
	nuint32 sipxStatus;
	char  displayMessage[1024];
	PSIPX_CONN_INFO		pConnInfo;
	nuint32				connInfoLength;


	sipxStatus = NWSipxGetInformation(
						/* Info type     		*/ SIPX_CONN_INFORMATION,
						/* handle        		*/ pSndThreadInfo->connHandle,
						/* info struct   		*/ (void **)&pConnInfo,
						/* info struct len 	*/ &connInfoLength
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxGetInformation() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		}

	wsprintf(displayMessage, "Connection State is: %08X", pConnInfo->CIState);
	MessageBox(NULL, displayMessage,"Connection State", MB_OK);

	sipxStatus = NWSipxFreeInformation(
					/* pInfoStruct     */ pConnInfo
					);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxFreeInformation() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		}

	sipxStatus = NWSipxAllocControlBlock(
						/* Sync Type        */ SIPX_API_EVENT,
						/* pEventInfo		  */ NULL,
						/* Pnt NWTCB   	  */ &pSndNWTCB
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxAllocControlBlock() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		return FALSE;
		}
	
	/*--------------------------------------------------------------------
	** Set up NWTCB fields for send.
	*/

	memcpy(&pSndNWTCB->TCBRemoteAddress, &pSndThreadInfo->netAddress, sizeof(NETADDR));
	tsduSize =  NWSipxGetMaxTsduSize(pSndThreadInfo->connHandle);
	sndFrag.FLength = tsduSize;
	sndFrag.FAddress = GlobalAlloc(GPTR, sndFrag.FLength);
	pSndNWTCB->TCBConnHandle = pSndThreadInfo->connHandle;
	pSndNWTCB->TCBFragmentList = &sndFrag;
	pSndNWTCB->TCBFragmentCount = 1;

	 SendDlgItemMessage(pSndThreadInfo->hwnd, IDC_SEND_DATA, WM_GETTEXT, /* sizeof(sndFrag.FLength) */ 1024, 
			(LONG) (LPSTR) sndFrag.FAddress);

	 if((strlen((char *)sndFrag.FAddress) + strlen(pSndThreadInfo->myName)) < tsduSize)
			strcat((char *)sndFrag.FAddress, pSndThreadInfo->myName);
	 else 
		{
		wsprintf(displayMessage, "Message too large. Reduce size and try again.");
		MessageBox(NULL, displayMessage,"Message Too Big", MB_OK);
		goto _FreeFrag;
		}

	pSndNWTCB->TCBFlags = 0;
	sipxStatus = NWSipxSendMessage(
						/* ptr NWTCB   */ pSndNWTCB
						);
	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxSendMessage() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		goto _FreeFrag;
		}

	sipxStatus = NWSipxWaitForSingleEvent(
						/* ptr NWTCB          */ pSndNWTCB,
						/* time out interval  */ SIPX_INFINITE_WAIT
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxWaitForSingleEvent() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		}

_FreeFrag:
	GlobalFree(sndFrag.FAddress);
_FreeNWTCB:
	NWSipxFreeControlBlock(pSndNWTCB);

	return 0;
}

DWORD ReceiveThread( PRCV_THREADINFO pRcvThreadInfo)
{
	PNWTCB	pRcvNWTCB;
	PNWTCB	pConnWatchNWTCB;
	FRAGMENT rcvFrag;
	nuint32	sipxStatus;
	char  displayMessage[1024];

	sipxStatus = NWSipxAllocControlBlock(
						/* Sync Type        */ SIPX_API_EVENT,
						/* pEventInfo		  */ NULL,
						/* Pnt NWTCB   	  */ &pRcvNWTCB
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxAllocControlBlock() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		return FALSE;
		}

	/*-------------------------------------------------------------------------
	** Save pointer to the receive NWTCB in the pRcvThreadInfo structure so 
	** that this event can be cancelled upon termination of the program.
	*/
	pRcvThreadInfo->rcvNWTCB = pRcvNWTCB;

	rcvFrag.FLength = NWSipxGetMaxTsduSize(pRcvThreadInfo->connHandle);
	rcvFrag.FAddress = GlobalAlloc(GPTR, rcvFrag.FLength);
	pRcvNWTCB->TCBFlags = 0;
	pRcvNWTCB->TCBFragmentCount = 1;
	pRcvNWTCB->TCBFragmentList = &rcvFrag;
	pRcvNWTCB->TCBConnHandle = pRcvThreadInfo->connHandle;


	/*------------------------------------------------------------------------
	** Set up an event to look for disconnect
	*/


			sipxStatus = NWSipxAllocControlBlock(
							/* Sync Type        */ SIPX_POLLING,
							/* pEventInfo		  */ NULL,
							/* Pnt NWTCB   	  */ &pConnWatchNWTCB
							);

		if (SIPX_ERROR(sipxStatus))
			{
			wsprintf(displayMessage, "NWSipxAllocControlBlock() returned %08X", sipxStatus);
			MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
			goto _FreercvNWTCB;
			}
							

		pConnWatchNWTCB->TCBFlags = 0;
		pConnWatchNWTCB->TCBConnHandle = pRcvThreadInfo->connHandle;
		pConnWatchNWTCB->TCBTransportEvent = SIPX_LISTEN_FOR_DISCONNECT;
		sipxStatus = NWSipxRegisterForTransportEvent(
							/* PTR NWTCB                */ pConnWatchNWTCB
							);

		if (SIPX_ERROR(sipxStatus))
			{
			wsprintf(displayMessage, "NWSipxRegisterForTransportEvent() returned %08X", sipxStatus);
			MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
			goto _FreeNWTCBs;
			}


	while((pRcvThreadInfo->terminateFlag) || (NWSipxPoll(pConnWatchNWTCB) == SIPX_PENDING))
		{
		sipxStatus = NWSipxReceiveMessage(
							/* ptr NWTCB     */ pRcvNWTCB
							);

		if (SIPX_ERROR(sipxStatus))
			{
			wsprintf(displayMessage, "NWSipxReceiveMessage() returned %08X", sipxStatus);
			MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
			goto _FreeNWTCBs;
			}
		
		sipxStatus = NWSipxWaitForSingleEvent(
							/* ptr NWTCB          */ pRcvNWTCB,
							/* time out interval  */ SIPX_INFINITE_WAIT
							);


		if (SIPX_ERROR(sipxStatus))
			{
			wsprintf(displayMessage, "NWSipxWaitForSingleEvent() returned %08X", sipxStatus);
			MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
			goto _FreeNWTCBs;
			}

		wsprintf(displayMessage, "%s\r\n", (char *)pRcvNWTCB->TCBFragmentList->FAddress);
		
		if(strlen(displayMessage) + strlen(globalMessage) < MAX_MESSAGE_SIZE)
			{
			strcpy(tempMessage, displayMessage);
			strcat(tempMessage, globalMessage);
			strcpy(globalMessage, tempMessage);
			}
		else
			{
			memset(globalMessage, 0, sizeof(globalMessage));
			strcpy(tempMessage, displayMessage);
			strcat(tempMessage, globalMessage);
			strcpy(globalMessage, tempMessage);
			}

		SendDlgItemMessage(pRcvThreadInfo->hwnd, IDC_DISPLAY_DATA, WM_SETTEXT, 0, 
								(LONG) (LPSTR) globalMessage);

		}

_FreeNWTCBs:
	NWSipxFreeControlBlock(pConnWatchNWTCB);
_FreercvNWTCB:
	NWSipxFreeControlBlock(pRcvNWTCB);
	GlobalFree(rcvFrag.FAddress);
	return FALSE;

}
BOOL InitConnection(NETADDR *pNetAddress, 
						  HWND hwnd, 
						  PSIPXCONN_HANDLE sipxHandle,
						  pnuint8	initCompleteFlag)
{
	static FARPROC lpfnGetNetAddressDlgProc;
	SIPXSUBNET_HANDLE hSubnetworkHandle = 0;
	PNWTCB	pEstabNWTCB;
	FRAGMENT estabFrag;
	char		tempString[25];
	int		i, strCount=0;
	int		rval;
	nuint32 sipxStatus;
	nuint16 sipxSocket = 0;
	IPXADDRESS	ipxAddr;
	char  displayMessage[1024];
	

	lpfnGetNetAddressDlgProc = MakeProcInstance ((FARPROC) GetNetAddressDlgProc, globalhInstance);

	rval = DialogBox(globalhInstance, "NET_ADDR", hwnd, lpfnGetNetAddressDlgProc);

	if(rval == -1)
			{
			 wsprintf(displayMessage, "Call to DialogBox() returned %d", rval);
			 MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
			 return FALSE;
			}


	for(i=0; i<28; ++i)
		{
		if(inetString[i] != ':')
			{
			tempString[strCount] = inetString[i];
			strCount +=1;
			}
		}

	strToHex(tempString, (unsigned char *)&ipxAddr, 12);

	pNetAddress->NAType = TA_IPX_SPX;
	pNetAddress->NALength = sizeof(IPXADDR);
	memcpy(&pNetAddress->NAAddress, &ipxAddr, sizeof(NETADDR));

	sipxStatus = NWSipxAllocControlBlock(
						/* Sync Type        */ SIPX_API_EVENT,
						/* pEventInfo		  */ NULL,
						/* Pnt NWTCB   	  */ &pEstabNWTCB
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxAllocControlBlock() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		return FALSE;
		}

	sipxStatus = NWSipxOpenConnectionEndpoint(
						/* sub network handle    */ hSubnetworkHandle,
						/* socket to be opened   */ &sipxSocket,
						/* connection handle     */ sipxHandle
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxOpenConnectionEndpoint() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		goto _FreeNWTCB;
		}

	/*--------------------------------------------------------------------
	** Set up NWTCB fields for send.
	*/
	pEstabNWTCB->TCBConnHandle = *(sipxHandle);
	pEstabNWTCB->TCBFragmentList = &estabFrag;
	pEstabNWTCB->TCBFragmentCount = 1;

	memcpy(&pEstabNWTCB->TCBRemoteAddress, pNetAddress, sizeof(NETADDR));
	tsduSize =  NWSipxGetMaxTsduSize(*(sipxHandle));
	estabFrag.FLength = tsduSize;
	estabFrag.FAddress = GlobalAlloc(GPTR, estabFrag.FLength);

	sipxStatus = NWSipxEstablishConnection(
						/* ptr to NWTCB       */ pEstabNWTCB
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxEstablishConnection() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		goto _FreeFrag;
		}

	sipxStatus = NWSipxWaitForSingleEvent(
						/* ptr NWTCB          */ pEstabNWTCB,
						/* time out interval  */ SIPX_INFINITE_WAIT
						);

	if (SIPX_ERROR(sipxStatus))
		{
		wsprintf(displayMessage, "NWSipxWaitForSingleEvent() returned %08X", sipxStatus);
		MessageBox(NULL, displayMessage,"Function Failed", MB_OK);
		goto _FreeFrag;
		}

	if(pEstabNWTCB->TCBFinalStatus == SIPX_SUCCESSFUL)
		{
		*initCompleteFlag = 1;
		memcpy(pNetAddress, &pEstabNWTCB->TCBRemoteAddress, sizeof(NETADDR));
		}
	else
		{
		wsprintf(displayMessage, "Attempt to Establish Connection Failed! Return code: %08X", 
					pEstabNWTCB->TCBFinalStatus);
		MessageBox(NULL, displayMessage,"Establish Connection Failed!", MB_OK);
		}

_FreeFrag:
	GlobalFree(estabFrag.FAddress);

_FreeNWTCB:
	NWSipxFreeControlBlock(pEstabNWTCB);

 if(*initCompleteFlag)
	return TRUE;
 else
	return FALSE;
									
}


BOOL strToHex(char *ascii, unsigned char *hex, int length)
{
	int      i, j;
	char     tmp_char;

	for (i=0, j=0; i<2*length; i+=2,j++)
		{
		if (!isxdigit(tmp_char= (char) toupper(ascii[i])) )
			{
			return 0;
			}
		else
			hex[j] = ( (char)(tmp_char>'9') ?  (char)((tmp_char-0x37) << 4) : (char)((tmp_char-0x30) << 4));

		if(!isxdigit(tmp_char= (char) toupper(ascii[i+1])) )
			{
			return 0;
			}
		else
			hex[j] += ((char)(tmp_char > '9') ? (char)(tmp_char-0x37) : (char)(tmp_char-0x30) );

		}
	return 1;
}


BOOL FAR PASCAL GetNetAddressDlgProc(HWND hDlg, WORD msg, WORD wParam, DWORD lParam)
{
	switch(msg)
		{
		case WM_INITDIALOG:

		return TRUE;

		case WM_COMMAND:
			  switch(wParam)
						{
						case GET_NET_ADDR:
							SendDlgItemMessage(hDlg, IDC_NET_ADDR, WM_GETTEXT, sizeof(inetString), 
														(LONG) (LPSTR) inetString);
							if(strlen(inetString) == 0)
								{
								MessageBox(NULL, (LPSTR)"You must enter net:node address!", "Error!", IDOK);
								break; 
								}

							SendDlgItemMessage(hDlg, IDC_GET_NAME, WM_GETTEXT, sizeof(myName), 
														(LONG) (LPSTR) myName);

							if(strlen(myName) == 0)
								{
								MessageBox(NULL, (LPSTR)"You must enter your first name!", "Error!", IDOK);
								break; 
								}
								
							EndDialog(hDlg, TRUE);
							return TRUE;
						}
		}
		return FALSE;				
}
